var Filter = require('broccoli-filter');

var controller = new RegExp(/(^controllers\/)|(^models\/)|(^routes\/)/);
var jquery = new RegExp(/\W(\$\.)|(\.\$\.)|(\$\()/);
var chalk = require('chalk');

NoJquery.prototype = Object.create(Filter.prototype);
NoJquery.prototype.constructor = NoJquery;

function severe(offense) {
  console.log(chalk.red(offense));
}

function NoJquery(inputNode) {
  if (!(this instanceof NoJquery)) {
    return new NoJquery(inputNode);
  }

  Filter.call(this, inputNode);
};

NoJquery.prototype.extensions = ['js'];
NoJquery.prototype.targetExtension = 'js';

NoJquery.prototype.processString = function (content, relativePath) {
  if (controller.test(relativePath) && jquery.test(content)) {
    content.split('\n').forEach(function(line, idx) {
      var found = line.match(jquery);
      if (found) {
        severe('[no-jquery] jQuery line ' + idx + ' of ' + relativePath);
        severe(line);
      }
    });
  }
};

module.exports = NoJquery;
